use clap::{Args, Parser, Subcommand};

#[derive(Parser, Clone)]
pub struct Cli {
    #[command(flatten)]
    pub verbose: clap_verbosity_flag::Verbosity,

    #[arg(long, default_value = "localhost")]
    pub redis_host: String,

    #[arg(long, default_value_t = 6379)]
    pub redis_port: u16,

    #[command(subcommand)]
    pub command: MyCommand,
}

#[derive(Subcommand, Clone)]
pub enum MyCommand {
    WebServer(WebServerArgs),
    SocketServer(SocketServerArgs),
}

#[derive(Args, Clone)]
pub struct WebServerArgs {
    #[arg(short, long, default_value = "localhost")]
    pub addr: String,

    #[arg(short, long, default_value_t = 8080)]
    pub port: u16,
}

#[derive(Args, Clone)]
pub struct SocketServerArgs {
    #[arg(short, long, default_value = "localhost")]
    pub addr: String,

    #[arg(short = 'p', default_value_t = 8283)]
    pub port: u16,
}