use crate::web_server::app_error::{self, AppError};
use crate::web_server::old_app_api::types::AppInitRequest;
use crate::web_server::NMAppState;

use serde_json::{json};
use snafu::ResultExt;


use crate::insert_header;
use fred::interfaces::KeysInterface;
use ntex::http::StatusCode;
use ntex::web;



pub async fn app_init(
    _body: AppInitRequest<'_>,
    app_state: &NMAppState,
) -> Result<web::HttpResponse, AppError> {
    let _: () = app_state
        .redis_client
        .set("test", 123, None, None, true)
        .await.context(app_error::ServerRedisSnafu)?;

    Ok(web::HttpResponse::build(StatusCode::OK).body("Hello world!"))
}

pub async fn version(_body: (), _app_state: &NMAppState) -> Result<web::HttpResponse, AppError> {
    let mut resp = web::HttpResponse::build(StatusCode::OK).json(&json!({
        "version": "indev",
        "iotishnik": true
    }));

    insert_header!(resp.headers_mut(), "Cache-Control", "no-cache");

    Ok(resp)
}
